"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var forms_1 = require('@angular/forms');
var plenty_text_input_component_1 = require('../../forms/input/text-input/plenty-text-input.component');
var plenty_number_input_component_1 = require('../../forms/input/number-input/plenty-number-input.component');
var plenty_double_input_component_1 = require('../../forms/input/double-input/plenty-double-input.component');
var plenty_button_component_1 = require('../../button/plenty-button.component');
var InputShowcaseComponent = (function () {
    function InputShowcaseComponent(formBuilder) {
        this.formBuilder = formBuilder;
        this.form = {};
        this.validationInputName = 'Validierbar';
        this.maxLengthInputName = 'MaxLength 3';
        this.minLengthInputName = 'MinLength 4';
        this.disabledValidInputName = 'Disabled Input';
        this.numberInputName = 'Number Input';
        this.doubleInputName = 'Double Input';
    }
    InputShowcaseComponent.prototype.ngOnInit = function () {
        this.disabledInput.isDisabled = true;
        this.disabledValidInput.isDisabled = true;
        this.numberInputFormControl = new forms_1.FormControl('', [forms_1.Validators.required,
            forms_1.Validators.pattern(this.numberInput.regex)]);
        this.doubleInputFormControl = new forms_1.FormControl('', [forms_1.Validators.required,
            forms_1.Validators.pattern(this.doubleInput.regex)]);
        this.requiredFormControl = new forms_1.FormControl('', forms_1.Validators.required);
        this.maxLengthFormControl = new forms_1.FormControl('', [forms_1.Validators.maxLength(3),
            forms_1.Validators.required]);
        this.minLengthFormControl = new forms_1.FormControl('', [forms_1.Validators.minLength(4),
            forms_1.Validators.required]);
        this.disabledValidFormControl = new forms_1.FormControl('', forms_1.Validators.required);
        this.form[this.numberInputName] = this.numberInputFormControl;
        this.form[this.validationInputName] = this.requiredFormControl;
        this.form[this.maxLengthInputName] = this.maxLengthFormControl;
        this.form[this.minLengthInputName] = this.minLengthFormControl;
        this.form[this.disabledValidInputName] = this.disabledValidFormControl;
        this.validationForm = this.formBuilder.group(this.form);
    };
    InputShowcaseComponent.prototype.validate = function (event, validationInputValue, minLengthInputValue, maxLengthInputValue, numberInputValue, doubleInputValue) {
        event.preventDefault();
        this.requiredFormControl.updateValue(validationInputValue);
        this.maxLengthFormControl.updateValue(maxLengthInputValue);
        this.minLengthFormControl.updateValue(minLengthInputValue);
        this.numberInputFormControl.updateValue(numberInputValue);
        this.doubleInputFormControl.updateValue(doubleInputValue);
        this.numberInput.validate(this.numberInputFormControl);
        this.doubleInput.validate(this.doubleInputFormControl);
        this.validationInput.validate(this.requiredFormControl);
        this.maxLengthInput.validate(this.maxLengthFormControl);
        this.minLengthInput.validate(this.minLengthFormControl);
        this.disabledValidInput.validate(this.disabledValidFormControl);
    };
    __decorate([
        core_1.ViewChild('validationInput'), 
        __metadata('design:type', plenty_text_input_component_1.PlentyTextInputComponent)
    ], InputShowcaseComponent.prototype, "validationInput", void 0);
    __decorate([
        core_1.ViewChild('maxLengthInput'), 
        __metadata('design:type', plenty_text_input_component_1.PlentyTextInputComponent)
    ], InputShowcaseComponent.prototype, "maxLengthInput", void 0);
    __decorate([
        core_1.ViewChild('minLengthInput'), 
        __metadata('design:type', plenty_text_input_component_1.PlentyTextInputComponent)
    ], InputShowcaseComponent.prototype, "minLengthInput", void 0);
    __decorate([
        core_1.ViewChild('disabledInput'), 
        __metadata('design:type', plenty_text_input_component_1.PlentyTextInputComponent)
    ], InputShowcaseComponent.prototype, "disabledInput", void 0);
    __decorate([
        core_1.ViewChild('disabledValidInput'), 
        __metadata('design:type', plenty_text_input_component_1.PlentyTextInputComponent)
    ], InputShowcaseComponent.prototype, "disabledValidInput", void 0);
    __decorate([
        core_1.ViewChild('numberInput'), 
        __metadata('design:type', plenty_number_input_component_1.PlentyNumberInputComponent)
    ], InputShowcaseComponent.prototype, "numberInput", void 0);
    __decorate([
        core_1.ViewChild('doubleInput'), 
        __metadata('design:type', plenty_number_input_component_1.PlentyNumberInputComponent)
    ], InputShowcaseComponent.prototype, "doubleInput", void 0);
    InputShowcaseComponent = __decorate([
        core_1.Component({
            moduleId: module.id,
            selector: 'input-showcase',
            templateUrl: 'input-showcase.component.html',
            directives: [plenty_text_input_component_1.PlentyTextInputComponent,
                plenty_number_input_component_1.PlentyNumberInputComponent,
                plenty_double_input_component_1.PlentyDoubleInputComponent,
                forms_1.REACTIVE_FORM_DIRECTIVES,
                plenty_button_component_1.PlentyButtonComponent],
        }), 
        __metadata('design:paramtypes', [forms_1.FormBuilder])
    ], InputShowcaseComponent);
    return InputShowcaseComponent;
}());
exports.InputShowcaseComponent = InputShowcaseComponent;

//# sourceMappingURL=input-showcase.component.js.map
