"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var Rx_1 = require('rxjs/Rx');
var plenty_data_table_component_1 = require('../../../table/data-table/plenty-data-table.component');
var ShowcaseTableDirective = (function () {
    function ShowcaseTableDirective(baseTable) {
        this.baseTable = baseTable;
        this.headerList = [];
    }
    ShowcaseTableDirective.prototype.ngOnInit = function () {
        var _this = this;
        this.baseTable.defaultPagingSize = 3;
        this.baseTable.pagingSize = [
            {
                value: 1,
                caption: '1'
            },
            {
                value: 3,
                caption: '3'
            },
            {
                value: 5,
                caption: '5'
            },
            {
                value: 10,
                caption: '10'
            }
        ];
        this.headerList.push({
            caption: 'ID',
            identifier: 'id',
            width: 100
        }, {
            caption: 'Kontakt-ID',
            identifier: 'contactId',
            width: 100
        }, {
            caption: 'Aufträge',
            identifier: 'orderCount',
            width: 100
        }, {
            caption: 'Unbez. Aufträge',
            tooltipText: 'Unbezahlte Aufträge',
            tooltipPlacement: 'top',
            identifier: 'unpaidOrdersCount',
            width: 100
        }, {
            caption: 'Σ unb. Aufträge',
            tooltipText: 'Gesamtsumme unbezahlte Aufträge',
            tooltipPlacement: 'top',
            identifier: 'unpaidOrderTotalAmount',
            width: 100
        }, {
            caption: 'Erstellt am',
            identifier: 'createdAt',
            width: 100
        }, {
            caption: 'Aktualisiert am',
            identifier: 'updatedAt',
            width: 100,
        }, {
            caption: '',
            identifier: 'actions',
            width: 200,
        });
        this.baseTable.headerList = this.headerList;
        var res = {
            "total": 16,
            "per_page": "3",
            "current_page": 1,
            "last_page": 6,
            "next_page_url": "her comes some url",
            "prev_page_url": null,
            "from": 1,
            "to": 3,
            "data": [{
                    "id": 1,
                    "addressId": null,
                    "contactId": "101",
                    "orderCount": 1,
                    "unpaidOrdersCount": 1,
                    "unpaidOrderTotalAmount": 269.99,
                    "createdAt": "2016-08-03 11:39:03",
                    "updatedAt": "2016-08-03 11:39:03"
                },
                {
                    "id": 2,
                    "addressId": null,
                    "contactId": "102",
                    "orderCount": 3,
                    "unpaidOrdersCount": 1,
                    "unpaidOrderTotalAmount": 2099,
                    "createdAt": "2016-08-03 11:39:03",
                    "updatedAt": "2016-08-03 11:39:03"
                },
                {
                    "id": 3,
                    "addressId": null,
                    "contactId": "103",
                    "orderCount": 0,
                    "unpaidOrdersCount": 0,
                    "unpaidOrderTotalAmount": 0,
                    "createdAt": "2016-08-03 11:39:03",
                    "updatedAt": "2016-08-03 11:39:03"
                }]
        };
        var rowList = [];
        var total = res['total'];
        var perPage = res['per_page'];
        var currentPage = res['current_page'];
        var lastPage = res['last_page'];
        var from = res['from'];
        var to = res['to'];
        this.baseTable.pagingData = {
            pagingUnit: 'Entries',
            total: total,
            currentPage: currentPage,
            perPage: perPage,
            lastPage: lastPage,
            from: from,
            to: to
        };
        var dataList = res['data'];
        var _loop_1 = function(index) {
            var data = dataList[index];
            var row;
            var buttonList = [{
                    icon: 'icon-add',
                    tooltipText: 'Hinzufügen',
                    clickFunction: function () {
                        alert("Add clicked");
                    }
                },
                {
                    icon: 'icon-cancel',
                    tooltipText: 'Abbrechen',
                    clickFunction: function () {
                        alert("Cancel clicked");
                    }
                },
                {
                    icon: 'icon-delete',
                    tooltipText: 'Löschen',
                    clickFunction: function () {
                        _this.baseTable.deleteRow(row);
                    }
                }];
            var cellList = [{
                    caption: data.id,
                    identifier: 'id'
                },
                {
                    caption: data.contactId,
                    identifier: 'contactId'
                },
                {
                    caption: data.orderCount,
                    identifier: 'orderCount'
                },
                {
                    caption: data.unpaidOrdersCount,
                    identifier: 'unpaidOrdersCount'
                },
                {
                    caption: data.unpaidOrderTotalAmount,
                    identifier: 'unpaidOrderTotalAmount'
                },
                {
                    caption: data.createdAt,
                    identifier: 'createdAt'
                },
                {
                    caption: data.updatedAt,
                    identifier: 'updatedAt',
                    tooltipText: 'Aktualisiert am',
                    tooltipPlacement: 'bottom',
                },
                {
                    identifier: 'actions',
                    buttonList: buttonList
                },];
            var contextMenuLinkList = [
                {
                    title: 'Eintrag 1',
                    subject: new Rx_1.Subject(),
                    clickFunction: function (value) { return _this.contextMenuCallback(value); },
                    data: data
                },
                {
                    title: 'Eintrag 2',
                    subject: new Rx_1.Subject(),
                    clickFunction: function (value) { return _this.contextMenuCallback(value); },
                    data: data
                },
                {
                    subject: new Rx_1.Subject(),
                    isDivider: true
                },
                {
                    title: 'Eintrag 3',
                    subject: new Rx_1.Subject(),
                    clickFunction: function (value) { return _this.contextMenuCallback(value); },
                    data: data
                }
            ];
            row = {
                cellList: cellList,
                data: data,
                clickFunction: function () {
                    alert('ROW with ID ' + data.id + ' clicked!!!!');
                },
                contextMenuLinkList: contextMenuLinkList
            };
            rowList.push(row);
        };
        for (var index in dataList) {
            _loop_1(index);
        }
        this.baseTable.rowList = rowList;
    };
    ShowcaseTableDirective.prototype.onPaging = function (pagerData) {
        this.baseTable.doSearch(this.baseTable.service.getOrdersummary(pagerData.currentPage, pagerData.perPage));
    };
    ShowcaseTableDirective.prototype.contextMenuCallback = function (value) {
        alert(value.data.id);
    };
    __decorate([
        core_1.HostListener('doPagingEvent', ['$event']), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', [Object]), 
        __metadata('design:returntype', void 0)
    ], ShowcaseTableDirective.prototype, "onPaging", null);
    ShowcaseTableDirective = __decorate([
        core_1.Directive({
            selector: 'plenty-data-table[showcaseTable]'
        }), 
        __metadata('design:paramtypes', [plenty_data_table_component_1.PlentyDataTableComponent])
    ], ShowcaseTableDirective);
    return ShowcaseTableDirective;
}());
exports.ShowcaseTableDirective = ShowcaseTableDirective;

//# sourceMappingURL=showcase-table.directive.js.map
